AdjustablePersonalLight = {};

function AdjustablePersonalLight:loadMap(name)
    self.MaxRange = 100
    self.MinRange = 5
end

function AdjustablePersonalLight:mouseEvent(posX, posY, isDown, isUp, button)
    if isUp then return end

    if not Input.isKeyPressed(Input.KEY_rshift) then return end

    if button ~= 4 and button ~= 5 then return end

    if not g_currentMission.controlledVehicle and g_currentMission.player.isTorchActive then
        self:AdjustPersonalLight(button ~= 5)
    end
end

function AdjustablePersonalLight:AdjustPersonalLight(MoreOrLess)
    self:ChangeLightByNode(MoreOrLess,g_currentMission.player.model.lightNode, self.MinRange, self.MaxRange)
end

function AdjustablePersonalLight:ChangeLightByNode(MoreOrLess, NodeId, Min, Max)
    local CurrentRange = getLightRange(NodeId);
    local Change = MoreOrLess and 1 or -1
    local NewLevel = CurrentRange + Change;
    NewLevel = math.max(Min, math.min(NewLevel, Max))
    setLightRange(NodeId,NewLevel)

    return NewLevel
end

function AdjustablePersonalLight:update(dt)
    if not g_currentMission.controlledVehicle and g_currentMission.player.isTorchActive and Input.isKeyPressed(Input.KEY_rshift) then
        local CurrentRange = getLightRange(g_currentMission.player.model.lightNode);
        g_currentMission:addExtraPrintText(g_i18n:getText("construction_tab_lights").." | ".. CurrentRange.."m");
    end
end

function AdjustablePersonalLight:InputBlocker(super, ...)
    if not AdjustablePersonalLight.BlockInputs then super(self, ...) end
end

addModEventListener(AdjustablePersonalLight);
